<?php

if (file_exists("../base.php")){
	require_once "../base.php";
}else if(file_exists("base.php")){
	require_once "base.php";
}

require_once $baseDir."/includes/config.php";
require_once $baseDir."/includes/session.php";
require_once $baseDir."/classes/authenticator.class.php";

//database data
$host = $dPconfig['dbhost'];
$db = $dPconfig['dbname'];
$dbuser = $dPconfig['dbuser'];
$dbpw  = $dPconfig['dbpass'];


$devtest =false; //for testing in browser without post data


/**
 * check Login on dotProject
 * @return false or user_id
 */
function checkLogin($user,$password) {
	
	$user = ($user);
	
	if(isset($_POST['ldap']) &&  $_POST['ldap'] == 1){
	 	//ldap on
		$auth =&getauth('ldap');

		$auth->fallback = false;

		if (!$auth->authenticate($user, $password)) {
			return false;
		}
		return true;

	}else{
		
		//ldap off
		$query="
		SELECT `user_id`, `user_password`
		FROM `users`
		WHERE `user_username`='".$user."'
			AND `user_password` = '".MD5($password)."'";


		$result = mysql_query($query);
		$row = mysql_fetch_array($result);

		
		if (mysql_num_rows($result)!=0)
			return $row['user_id'];
		else return false;
	}
}

/**
 * Writes time and notes etc. of tasks to database
 */
function writeTaskLogToDB($user_id){

	$tasks_ids = explode("]|[",$_POST['ids']);	//Tasks ids
	$tasks = explode("]|[",$_POST['tasks']);	//Tasksnames
	$tasks_percents = explode("]|[",$_POST['percents']);
	$tasks_times = explode("]|[",$_POST['times']);
	$tasks_dates = explode("]|[",$_POST['dates']);
	$tasks_notes = explode("]|[",$_POST['notes']);

	if(sizeof($tasks_ids)!=0){
		for($j=0;$j < sizeof($tasks_ids);$j++){

			if($tasks_ids[$j] !=0){

				//convert time to dotproject format
				$tasks_times[$j] = timeToDpFormat($tasks_times[$j]);

				//insert data
				$query ="INSERT INTO `task_log` (`task_log_task`, `task_log_name`, `task_log_description`, `task_log_creator`, `task_log_hours`, `task_log_date`)".
						"VALUES (".$tasks_ids[$j].", '".utf8_decode($tasks[$j])."','".addslashes(utf8_decode($tasks_notes[$j]))."', ".$user_id.", ".trim($tasks_times[$j]).", '".trim($tasks_dates[$j])."')";
				$log1 .="query: ".$query;

				if(mysql_query($query)){

					//update percent value of task
					if($tasks_percents[$j] != ""){
						$query2 ="UPDATE `tasks` SET `task_percent_complete`=".$tasks_percents[$j]."  WHERE `task_id`=".$tasks_ids[$j]."";
						mysql_query($query2);
						$log1 .="\n\nquery2: ".$query2;
					}

					//return ids of updated tasks
					$updated_tasks_ids .="<id><![CDATA[".$tasks_ids[$j]."]]></id>";
				}
			}
		}
		return $updated_tasks_ids;
	}

}

/**
 * Create daily-report
 */
function dailyReport($user_id,$user){

	header ("Content-Type: text/html charset=utf-8");	// UTF-8 charset

	$time = time();
	$datum = getdate($time);

	if($datum[mon] < 10) $datum[mon] = "0".$datum[mon];
	if($datum[mday] < 10) $datum[mday] = "0".$datum[mday];

	$query = "
	SELECT `task_log_name`, `task_log_hours`, `task_log_description`, `task_log_date`
	FROM `task_log`
	WHERE `task_log_creator` =".$user_id."
		AND task_log_date > CONCAT(CURRENT_DATE(), ' 00:00:00')
		AND task_log_date < CONCAT(CURRENT_DATE(), ' 23:59:59')
	ORDER BY `task_log_date`";


	$result = mysql_query($query);

	$report .= "
			<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>" .
			"<html>".
			"<head>".
			"<meta http-equiv='Content-Type' content='text/html; charset=utf-8'/>".
			"<title>Daily report of ".$user." at ".$datum[mday].".".$datum[mon].".".$datum[year]."</title>" .
			"</head>".
			"<body>".
			"<h2>Daily report of ".$user." at ".$datum[mday].".".$datum[mon].".".$datum[year]."</h2>" .
			"\n<table border='1'>" .
			"\n<tr><th width='300' >Task</th><th width='60'>Time</th><th width='40'>Duration (hrs.min)</th><th width='500'>Notes</th></tr>";

			while($result_row = mysql_fetch_array($result)){

				$tasktime = date("H:i",strtotime($result_row['task_log_date']));

				//Convert time from DP-format to "hours.minutes"
				$result_row['task_log_hours'] = timeFromDpFormat($result_row['task_log_hours']);

				$report .= "\n<tr>";
				$report .= "<td valign='top'>".$result_row['task_log_name']."</td>";
				$report .= "<td valign='top' align='right'>".$tasktime."</td>";
				$report .= "<td valign='top' align='right'>".$result_row['task_log_hours']."</td>";
				$report .= "<td valign='top'>".$result_row['task_log_description']."</td>";
				$report .= "\n</tr>";

			}

			$report .="
			\n</table>".
			"</body>".
			"</html>";

	return $report;
	mysql_free_result($result);

}


/**
 * Converts the dotProject time format to "hours.minutes" format
 * $time - String x.xx hours
 *
 * @return String - "hours.minutes"
 */
function timeFromDpFormat($time){

	$timearray = explode(".",$time);
	$hrs = $timearray[0];
	$mins = $timearray[1];

	if(strlen($mins) == 1)
		$mins = intval($mins."0");
	else $mins = intval($mins);


	$mins  = round($mins*(3/5));

	if($mins < 10)
		$mins = "0".strval($mins);

	return $hrs.".".$mins;

}

/**
 * Converts to the dotProject time format
 * $time - String "hours.minutes"
 *
 * @return String - x.xx hours
 */
function timeToDpFormat($time){

	$timearray = explode(".",$time);
	$hrs = $timearray[0];
	$mins = $timearray[1];

	if(strlen($mins) == 1)
		$mins = intval($mins."0");
	else $mins = intval($mins);

	$mins = round($mins*(5/3));

	if($mins <10)
		$mins = "0".strval($mins);

	return $hrs.".".$mins;

}

//-----------------------------------------------------------------------------------

if($_SERVER['REQUEST_METHOD'] == 'POST' || $devtest ){

	//username and password
	if(isset($_POST['user']) && isset($_POST['pw'])){
		$user = utf8_decode($_POST['user']);
		$pw = utf8_decode($_POST['pw']);
	}else{
		//only for testing
		$user = "admin";
		$pw = "passwd";
	}
	//variables for filter projects / tasks
	$projectStatus = $_POST['ps'];
	$taskFilter = $_POST['tf'];
	
	//connect do db
	$con_id = @mysql_connect($host,$dbuser,$dbpw);
	@mysql_select_db($db,$con_id);

	//changed
	if(mysql_errno() !=0){
		$info_msg = "0001"; //Database Error - see logfile
		$log .= date("Y-m-d - H:i:s").": Database Error: ".mysql_error()."\n";
	}else if(!$user_id = checkLogin($user,$pw) ){
		$info_msg = "0002";	//Error-Massage: Check username / password!
		$log .= date("Y-m-d - H:i:s").": Unknown user or incorrect password. Username:".$user."\n";
	}else {

		//write times and notes of tasks in task_log
		if(isset($_POST['ids'])){
			$updated_tasks = writeTaskLogToDB($user_id);
		}

		//check if the daily-report should be generated
		if(isset($_POST['report'])){
			$makeReport = true;
		}
		else {
			$makeReport = false;

			//----------------- get project- and taskdata ---------------------------

			//filter tasks with 100%
			if($taskFilter == 1)
				$task_percent_complete ="AND task_percent_complete < 100";
			else $task_percent_complete = "";

			//filter tasks by project status
			if($projectStatus != 'x' && $projectStatus != '')
				$project_status = "AND p.project_status =".$projectStatus;
			else  $project_status ="";

			

			//make query for companies,projects and tasks
			$query = "
			SELECT *
			FROM user_tasks AS ut
			JOIN tasks AS t
			JOIN projects AS p
			JOIN companies As c
			ON (ut.user_id = ".$user_id." AND ut.task_id = t.task_id)
			AND p.project_company = c.company_id
			AND t.task_project = p.project_id ".$project_status." ".$task_percent_complete."
			ORDER BY c.company_name,p.project_name,t.task_name";
			//$log .= $query;
			$result = mysql_query($query);

			echo mysql_error();
			
			if(mysql_num_rows($result) == 0){
				$info_msg .= "0003";	//no tasks available
			}else{
				$lastCompanyId = 0;
				$lastProjectId = 0;

				//----------------- generate xml content for project- and taskdata  ---------------------------
				while($row = mysql_fetch_array($result)){

					//check if current project is a new one
					if($lastProjectId != $row['project_id']){

						//close tag of last project
						if($lastProjectId != 0)
							$data .="</tasks></project>";
						$lastProjectId = $row['project_id'];
						$newProject = true;
						$firstTask = true;
					}else{
						$newProject = false;
						$firstTask = false;
					}

					//check if current company is a new one
					if($lastCompanyId != $row['company_id']){

						//close tag of last company
						if($lastCompanyId != 0)
							$data .="</projects></company>";

						$lastCompanyId = $row['company_id'];

						//companies -------------------------------------------------------------------
						$data .=
						"<company id='".$row['company_id']."'>".
							"<name><![CDATA[".$row['company_name']."]]></name>".
							"<projects>";
					}

					//projects -------------------------------------------------------------------
					if($newProject){

						//get start- and enddate of the current project
						$projectStartDate = date("d.m.y",strtotime($row['project_start_date']));
						if($row['project_end_date'] != "")
							$projectEndDate = date("d.m.y",strtotime($row['project_end_date']));
						else $projectEndDate ="";
						//get the actuael end date
						$query_act_end_date="
						SELECT task_project, task_id AS critical_task, MAX(task_end_date) AS project_actual_end_date
						FROM tasks
						JOIN projects AS p
						ON p.project_id = task_project
						WHERE task_project = ".$row['project_id']."
						GROUP BY task_project
						ORDER BY task_end_date DESC";
						$res_act_end_date = mysql_query($query_act_end_date);
					    $row_act_end_date = mysql_fetch_array($res_act_end_date);
						$projectActEndDate = date("d.m.y",strtotime($row_act_end_date['project_actual_end_date']));

						//get progress of project în percent
						$query_percent ="
						SELECT
						SUM(t1.task_duration*t1.task_duration_type*t1.task_percent_complete) / SUM(t1.task_duration*t1.task_duration_type)
						AS project_percent_complete
						FROM projects JOIN tasks AS t1
						ON projects.project_id = t1.task_project
						WHERE project_id =".$row['project_id'];

						$res_percent = mysql_query($query_percent);
					    $row_percent = mysql_fetch_array($res_percent);

						//get project owner
						$query_owner = "
						SELECT user_username
						FROM users
						WHERE user_id =".$row['project_owner'];

					    $res_owner = mysql_query($query_owner);
					    $row_owner = mysql_fetch_array($res_owner);

						//changed all to cdata an query for duration
						$query_dur = "
						SELECT SUM(task_duration) AS duration
						FROM tasks
						WHERE task_project=".$row['project_id']."
						GROUP BY task_project";

						$res_dur = mysql_query($query_dur);
					    $row_dur = mysql_fetch_array($res_dur);

					    //get worked time of a task
						$query_worked_time="
						SELECT SUM(task_log_hours) AS worked
						FROM tasks AS t
						JOIN task_log AS tl
						ON t.task_id = tl.task_log_task AND t.task_project = ".$row['project_id']."
						GROUP BY task_project";

						$res_worked_time = mysql_query($query_worked_time);
						$row_worked_time = mysql_fetch_array($res_worked_time);
						$projectWorkedTime = timeFromDpFormat(round($row_worked_time['worked'],2));



						$data .=
						"<project id='".$row['project_id']."'>".
							"<name><![CDATA[".$row['project_name']."]]></name>".
							"<status><![CDATA[".$row['project_status']."]]></status>".
							"<percent><![CDATA[".round($row_percent['project_percent_complete'],1)."]]></percent>" .
							"<description><![CDATA[".html_entity_decode($row['project_description'])."]]></description>".
							"<startdate><![CDATA[".$projectStartDate."]]></startdate>".
							"<enddate><![CDATA[".$projectEndDate."]]></enddate>".
							"<act_enddate><![CDATA[".$projectActEndDate."]]></act_enddate>".
							"<duration><![CDATA[".$row_dur['duration']."]]></duration>".
							"<worked_time><![CDATA[".$projectWorkedTime."]]></worked_time>".
							"<url><![CDATA[".$row['project_url']."]]></url>".
							"<demo_url><![CDATA[".$row['project_demo_url']."]]></demo_url>".
							"<priority><![CDATA[".$row['project_priority']."]]></priority>".
							"<type><![CDATA[".$row['project_type']."]]></type>".
							"<owner><![CDATA[".$row_owner['user_username']."]]></owner>";

					}

					//tasks -------------------------------------------------------------------
					if($firstTask){
						$data .="<tasks>";
					}

					$taskStartDate = date("d.m.y H:i",strtotime($row['task_start_date']));
					$taskEndDate = date("d.m.y H:i",strtotime($row['task_end_date']));

					//get worked time of a task
					$query_worked_time="
					SELECT sum( task_log_hours ) AS worked
					FROM task_log
					WHERE  task_log_task =".$row['task_id'];

					$res_worked_time = mysql_query($query_worked_time);
					$row_worked_time = mysql_fetch_array($res_worked_time);
					$tasksWorkedTime = timeFromDpFormat(round($row_worked_time['worked'],2));

					$data .=
					"<task id='".$row['task_id']."'>".
						"<name><![CDATA[".$row['task_name']."]]></name>" .
						"<percent><![CDATA[".$row['task_percent_complete']."]]></percent>" .
						"<description><![CDATA[".addslashes($row['task_description'])."]]></description>".
						"<priority><![CDATA[".$row['task_priority']."]]></priority>".
						"<startdate><![CDATA[".$taskStartDate."]]></startdate>".
						"<enddate><![CDATA[".$taskEndDate."]]></enddate>".
						"<duration><![CDATA[".$row['task_duration']."]]></duration>".
						"<worked_time><![CDATA[".$tasksWorkedTime."]]></worked_time>".
						"<url><![CDATA[".$row['task_related_url']."]]></url>".
						"<milestone><![CDATA[".$row['task_milestone']."]]></milestone>".
					"</task>";


				}
				$data .="</tasks></project></projects></company>";

			}
		}
	}

	// generate xml-file or daily report
	if(!$makeReport){

		header ("Content-Type: text/xml charset=utf-8");	// UTF-8 charset

		echo $xml_content .=
		"<?xml version='1.0' encoding='UTF-8'?>".
		"<content>".
			"<info><![CDATA[".$info_msg."]]></info>".
			"<updated>".$updated_tasks."</updated>".
			"<data>".$data."</data>".
		"</content>";


	}else{

		echo dailyReport($user_id,$user);
	}

}


//write file for testing
$log .="";
$logfile = "tasktrackerlog.txt";

if(file_exists($logfile) && filesize($logfile) <= 1024 ){
	$log .= file_get_contents($logfile);
}

$fp = fopen ($logfile,"w+");
fwrite($fp,$log);
fclose($fp);



?>